package types

type WestDexServiceRequestParams struct {
	FieldMapping map[string]string
	ApiID        string
}

var WestDexParams = map[string][]WestDexServiceRequestParams{
	"marriage": {
		{FieldMapping: G09SC02FieldMapping, ApiID: "G09SC02"}, // 单人婚姻
		{FieldMapping: G27BJ05FieldMapping, ApiID: "G27BJ05"}, // 借贷意向
		{FieldMapping: G28BJ05FieldMapping, ApiID: "G28BJ05"}, // 借贷行为
		{FieldMapping: G26BJ05FieldMapping, ApiID: "G26BJ05"}, // 特殊名单
		{FieldMapping: G34BJ03FieldMapping, ApiID: "G34BJ03"}, // 个人不良
		{FieldMapping: G35SC01FieldMapping, ApiID: "G35SC01"}, // 个人涉诉
		{FieldMapping: G05HZ01FieldMapping, ApiID: "G05HZ01"}, // 股东人企关系

	},
	"backgroundcheck": {
		{FieldMapping: G09SC02FieldMapping, ApiID: "G09SC02"}, // 单人婚姻
		{FieldMapping: G27BJ05FieldMapping, ApiID: "G27BJ05"}, // 借贷意向
		{FieldMapping: G28BJ05FieldMapping, ApiID: "G28BJ05"}, // 借贷行为
		{FieldMapping: G26BJ05FieldMapping, ApiID: "G26BJ05"}, // 特殊名单
		{FieldMapping: G05HZ01FieldMapping, ApiID: "G05HZ01"}, // 股东人企关系
		{FieldMapping: G34BJ03FieldMapping, ApiID: "G34BJ03"}, // 个人不良
		{FieldMapping: G35SC01FieldMapping, ApiID: "G35SC01"}, // 个人涉诉
	},
	"companyinfo": {
		{FieldMapping: G09SC02FieldMapping, ApiID: "G09SC02"}, // 单人婚姻
		{FieldMapping: G27BJ05FieldMapping, ApiID: "G27BJ05"}, // 借贷意向
		{FieldMapping: G28BJ05FieldMapping, ApiID: "G28BJ05"}, // 借贷行为
		{FieldMapping: G26BJ05FieldMapping, ApiID: "G26BJ05"}, // 特殊名单
		{FieldMapping: G05HZ01FieldMapping, ApiID: "G05HZ01"}, // 股东人企关系
		{FieldMapping: G34BJ03FieldMapping, ApiID: "G34BJ03"}, // 个人不良
		{FieldMapping: G35SC01FieldMapping, ApiID: "G35SC01"}, // 个人涉诉
	},
	"homeservice": {
		{FieldMapping: G09SC02FieldMapping, ApiID: "G09SC02"}, // 单人婚姻
		{FieldMapping: G27BJ05FieldMapping, ApiID: "G27BJ05"}, // 借贷意向
		{FieldMapping: G28BJ05FieldMapping, ApiID: "G28BJ05"}, // 借贷行为
		{FieldMapping: G26BJ05FieldMapping, ApiID: "G26BJ05"}, // 特殊名单
		{FieldMapping: G05HZ01FieldMapping, ApiID: "G05HZ01"}, // 股东人企关系
		{FieldMapping: G34BJ03FieldMapping, ApiID: "G34BJ03"}, // 个人不良
		{FieldMapping: G35SC01FieldMapping, ApiID: "G35SC01"}, // 个人涉诉
	},
	"preloanbackgroundcheck": {
		{FieldMapping: G09SC02FieldMapping, ApiID: "G09SC02"}, // 单人婚姻
		{FieldMapping: G27BJ05FieldMapping, ApiID: "G27BJ05"}, // 借贷意向
		{FieldMapping: G28BJ05FieldMapping, ApiID: "G28BJ05"}, // 借贷行为
		{FieldMapping: G26BJ05FieldMapping, ApiID: "G26BJ05"}, // 特殊名单
		{FieldMapping: G05HZ01FieldMapping, ApiID: "G05HZ01"}, // 股东人企关系
		{FieldMapping: G34BJ03FieldMapping, ApiID: "G34BJ03"}, // 个人不良
		{FieldMapping: G35SC01FieldMapping, ApiID: "G35SC01"}, // 个人涉诉
	},
	"rentalinfo": {
		{FieldMapping: G09SC02FieldMapping, ApiID: "G09SC02"}, // 单人婚姻
		{FieldMapping: G27BJ05FieldMapping, ApiID: "G27BJ05"}, // 借贷意向
		{FieldMapping: G28BJ05FieldMapping, ApiID: "G28BJ05"}, // 借贷行为
		{FieldMapping: G26BJ05FieldMapping, ApiID: "G26BJ05"}, // 特殊名单
		{FieldMapping: G05HZ01FieldMapping, ApiID: "G05HZ01"}, // 股东人企关系
		{FieldMapping: G34BJ03FieldMapping, ApiID: "G34BJ03"}, // 个人不良
		{FieldMapping: G35SC01FieldMapping, ApiID: "G35SC01"}, // 个人涉诉
	},
	"riskassessment": {
		{FieldMapping: G09SC02FieldMapping, ApiID: "G09SC02"}, // 单人婚姻
		{FieldMapping: G27BJ05FieldMapping, ApiID: "G27BJ05"}, // 借贷意向
		{FieldMapping: G28BJ05FieldMapping, ApiID: "G28BJ05"}, // 借贷行为
		{FieldMapping: G26BJ05FieldMapping, ApiID: "G26BJ05"}, // 特殊名单
		{FieldMapping: G05HZ01FieldMapping, ApiID: "G05HZ01"}, // 股东人企关系
		{FieldMapping: G34BJ03FieldMapping, ApiID: "G34BJ03"}, // 个人不良
		{FieldMapping: G35SC01FieldMapping, ApiID: "G35SC01"}, // 个人涉诉
	},
}
