// Code generated by goctl. DO NOT EDIT.
package types

type AdminCreateUserReq struct {
	Username string  `json:"username"`         // 用户名
	RealName string  `json:"real_name"`        // 真实姓名
	Status   int64   `json:"status,default=1"` // 状态：0-禁用，1-启用
	RoleIds  []int64 `json:"role_ids"`         // 关联的角色ID列表
}

type AdminCreateUserResp struct {
	Id int64 `json:"id"` // 用户ID
}

type AdminDeleteUserReq struct {
	Id int64 `path:"id"` // 用户ID
}

type AdminDeleteUserResp struct {
	Success bool `json:"success"` // 是否成功
}

type AdminGetUserDetailReq struct {
	Id int64 `path:"id"` // 用户ID
}

type AdminGetUserDetailResp struct {
	Id         int64   `json:"id"`          // 用户ID
	Username   string  `json:"username"`    // 用户名
	RealName   string  `json:"real_name"`   // 真实姓名
	Status     int64   `json:"status"`      // 状态：0-禁用，1-启用
	CreateTime string  `json:"create_time"` // 创建时间
	UpdateTime string  `json:"update_time"` // 更新时间
	RoleIds    []int64 `json:"role_ids"`    // 关联的角色ID列表
}

type AdminGetUserListReq struct {
	Page     int64  `form:"page,default=1"`             // 页码
	PageSize int64  `form:"pageSize,default=20"`        // 每页数量
	Username string `form:"username,optional"`          // 用户名
	RealName string `form:"real_name,optional"`         // 真实姓名
	Status   int64  `form:"status,optional,default=-1"` // 状态：0-禁用，1-启用
}

type AdminGetUserListResp struct {
	Total int64          `json:"total"` // 总数
	Items []UserListItem `json:"items"` // 列表
}

type AdminLoginReq struct {
	Username string `json:"username" validate:"required"`
	Password string `json:"password" validate:"required"`
	Captcha  bool   `json:"captcha" validate:"required"`
}

type AdminLoginResp struct {
	AccessToken  string   `json:"access_token"`
	AccessExpire int64    `json:"access_expire"`
	RefreshAfter int64    `json:"refresh_after"`
	Roles        []string `json:"roles"`
}

type AdminUpdateUserReq struct {
	Id       int64   `path:"id"`                 // 用户ID
	Username *string `json:"username,optional"`  // 用户名
	RealName *string `json:"real_name,optional"` // 真实姓名
	Status   *int64  `json:"status,optional"`    // 状态：0-禁用，1-启用
	RoleIds  []int64 `json:"role_ids,optional"`  // 关联的角色ID列表
}

type AdminUpdateUserResp struct {
	Success bool `json:"success"` // 是否成功
}

type AdminUserInfoReq struct {
}

type AdminUserInfoResp struct {
	Username string   `json:"username"`  // 用户名
	RealName string   `json:"real_name"` // 真实姓名
	Roles    []string `json:"roles"`     // 角色编码列表
}

type CreateMenuReq struct {
	Pid       int64                  `json:"pid,optional"`              // 父菜单ID
	Name      string                 `json:"name"`                      // 路由名称
	Path      string                 `json:"path,optional"`             // 路由路径
	Component string                 `json:"component,optional"`        // 组件路径
	Redirect  string                 `json:"redirect,optional"`         // 重定向路径
	Meta      map[string]interface{} `json:"meta"`                      // 路由元数据
	Status    int64                  `json:"status,optional,default=1"` // 状态：0-禁用，1-启用
	Type      string                 `json:"type"`                      // 类型
	Sort      int64                  `json:"sort,optional"`             // 排序
}

type CreateMenuResp struct {
	Id int64 `json:"id"` // 菜单ID
}

type CreatePromotionLinkReq struct {
	Name string `json:"name"` // 链接名称
}

type CreatePromotionLinkResp struct {
	Id  int64  `json:"id"`  // 链接ID
	Url string `json:"url"` // 生成的推广链接URL
}

type CreateRoleReq struct {
	RoleName    string  `json:"role_name"`        // 角色名称
	RoleCode    string  `json:"role_code"`        // 角色编码
	Description string  `json:"description"`      // 角色描述
	Status      int64   `json:"status,default=1"` // 状态：0-禁用，1-启用
	Sort        int64   `json:"sort,default=0"`   // 排序
	MenuIds     []int64 `json:"menu_ids"`         // 关联的菜单ID列表
}

type CreateRoleResp struct {
	Id int64 `json:"id"` // 角色ID
}

type DeleteMenuReq struct {
	Id int64 `path:"id"` // 菜单ID
}

type DeleteMenuResp struct {
	Success bool `json:"success"` // 是否成功
}

type DeletePromotionLinkReq struct {
	Id int64 `path:"id"` // 链接ID
}

type DeletePromotionLinkResp struct {
	Success bool `json:"success"` // 是否成功
}

type DeleteRoleReq struct {
	Id int64 `path:"id"` // 角色ID
}

type DeleteRoleResp struct {
	Success bool `json:"success"` // 是否成功
}

type Feature struct {
	ID    int64  `json:"id"`     // 功能ID
	ApiID string `json:"api_id"` // API标识
	Name  string `json:"name"`   // 功能描述
}

type GetMenuAllReq struct {
}

type GetMenuAllResp struct {
	Name      string                 `json:"name"`
	Path      string                 `json:"path"`
	Redirect  string                 `json:"redirect,omitempty"`
	Component string                 `json:"component,omitempty"`
	Sort      int64                  `json:"sort"`
	Meta      map[string]interface{} `json:"meta"`
	Children  []GetMenuAllResp       `json:"children"`
}

type GetMenuDetailReq struct {
	Id int64 `path:"id"` // 菜单ID
}

type GetMenuDetailResp struct {
	Id         int64                  `json:"id"`         // 菜单ID
	Pid        int64                  `json:"pid"`        // 父菜单ID
	Name       string                 `json:"name"`       // 路由名称
	Path       string                 `json:"path"`       // 路由路径
	Component  string                 `json:"component"`  // 组件路径
	Redirect   string                 `json:"redirect"`   // 重定向路径
	Meta       map[string]interface{} `json:"meta"`       // 路由元数据
	Status     int64                  `json:"status"`     // 状态：0-禁用，1-启用
	Type       string                 `json:"type"`       // 类型
	Sort       int64                  `json:"sort"`       // 排序
	CreateTime string                 `json:"createTime"` // 创建时间
	UpdateTime string                 `json:"updateTime"` // 更新时间
}

type GetMenuListReq struct {
	Name   string `form:"name,optional"`              // 菜单名称
	Path   string `form:"path,optional"`              // 路由路径
	Status int64  `form:"status,optional,default=-1"` // 状态：0-禁用，1-启用
	Type   string `form:"type,optional"`              // 类型
}

type GetNotificationsResp struct {
	Notifications []Notification `json:"notifications"` // 通知列表
	Total         int64          `json:"total"`         // 总记录数
}

type GetProductByEnRequest struct {
	ProductEn string `path:"product_en"`
}

type GetProductByIDRequest struct {
	Id int64 `path:"id"`
}

type GetProductRenderListRequest struct {
	Module string `path:"module"`
}

type GetProductRenderListResponse struct {
	Product []Product
}

type GetPromotionLinkDetailReq struct {
	Id int64 `path:"id"` // 链接ID
}

type GetPromotionLinkDetailResp struct {
	Name          string `json:"name"`                     // 链接名称
	Url           string `json:"url"`                      // 推广链接URL
	ClickCount    int64  `json:"click_count"`              // 点击数
	PayCount      int64  `json:"pay_count"`                // 付费次数
	PayAmount     string `json:"pay_amount"`               // 付费金额
	CreateTime    string `json:"create_time"`              // 创建时间
	UpdateTime    string `json:"update_time"`              // 更新时间
	LastClickTime string `json:"last_click_time,optional"` // 最后点击时间
	LastPayTime   string `json:"last_pay_time,optional"`   // 最后付费时间
}

type GetPromotionLinkListReq struct {
	Page     int64  `form:"page,default=1"`      // 页码
	PageSize int64  `form:"pageSize,default=20"` // 每页数量
	Name     string `form:"name,optional"`       // 链接名称
	Url      string `form:"url,optional"`        // 推广链接URL
}

type GetPromotionLinkListResp struct {
	Total int64               `json:"total"` // 总数
	Items []PromotionLinkItem `json:"items"` // 列表
}

type GetPromotionStatsHistoryReq struct {
	StartDate string `form:"start_date"` // 开始日期，格式：YYYY-MM-DD
	EndDate   string `form:"end_date"`   // 结束日期，格式：YYYY-MM-DD
}

type GetPromotionStatsTotalReq struct {
}

type GetPromotionStatsTotalResp struct {
	TodayPayAmount  float64 `json:"today_pay_amount"`  // 今日金额
	TodayClickCount int64   `json:"today_click_count"` // 今日点击数
	TodayPayCount   int64   `json:"today_pay_count"`   // 今日付费次数
	TotalPayAmount  float64 `json:"total_pay_amount"`  // 总金额
	TotalClickCount int64   `json:"total_click_count"` // 总点击数
	TotalPayCount   int64   `json:"total_pay_count"`   // 总付费次数
}

type GetRoleDetailReq struct {
	Id int64 `path:"id"` // 角色ID
}

type GetRoleDetailResp struct {
	Id          int64   `json:"id"`          // 角色ID
	RoleName    string  `json:"role_name"`   // 角色名称
	RoleCode    string  `json:"role_code"`   // 角色编码
	Description string  `json:"description"` // 角色描述
	Status      int64   `json:"status"`      // 状态：0-禁用，1-启用
	Sort        int64   `json:"sort"`        // 排序
	CreateTime  string  `json:"create_time"` // 创建时间
	UpdateTime  string  `json:"update_time"` // 更新时间
	MenuIds     []int64 `json:"menu_ids"`    // 关联的菜单ID列表
}

type GetRoleListReq struct {
	Page     int64  `form:"page,default=1"`             // 页码
	PageSize int64  `form:"pageSize,default=20"`        // 每页数量
	Name     string `form:"name,optional"`              // 角色名称
	Code     string `form:"code,optional"`              // 角色编码
	Status   int64  `form:"status,optional,default=-1"` // 状态：0-禁用，1-启用
}

type GetRoleListResp struct {
	Total int64          `json:"total"` // 总数
	Items []RoleListItem `json:"items"` // 列表
}

type IapCallbackReq struct {
	OrderID            int64  `json:"order_id" validate:"required"`
	TransactionReceipt string `json:"transaction_receipt" validate:"required"`
}

type MenuListItem struct {
	Id         int64                  `json:"id"`         // 菜单ID
	Pid        int64                  `json:"pid"`        // 父菜单ID
	Name       string                 `json:"name"`       // 路由名称
	Path       string                 `json:"path"`       // 路由路径
	Component  string                 `json:"component"`  // 组件路径
	Redirect   string                 `json:"redirect"`   // 重定向路径
	Meta       map[string]interface{} `json:"meta"`       // 路由元数据
	Status     int64                  `json:"status"`     // 状态：0-禁用，1-启用
	Type       string                 `json:"type"`       // 类型
	Sort       int64                  `json:"sort"`       // 排序
	CreateTime string                 `json:"createTime"` // 创建时间
	Children   []MenuListItem         `json:"children"`   // 子菜单
}

type MobileCodeLoginReq struct {
	Mobile string `json:"mobile"`
	Code   string `json:"code" validate:"required"`
}

type MobileCodeLoginResp struct {
	AccessToken  string `json:"accessToken"`
	AccessExpire int64  `json:"accessExpire"`
	RefreshAfter int64  `json:"refreshAfter"`
}

type MobileLoginReq struct {
	Mobile   string `json:"mobile" validate:"required,mobile"`
	Password string `json:"password" validate:"required"`
}

type MobileLoginResp struct {
	AccessToken  string `json:"accessToken"`
	AccessExpire int64  `json:"accessExpire"`
	RefreshAfter int64  `json:"refreshAfter"`
}

type Notification struct {
	Title            string `json:"title"`            // 通知标题
	Content          string `json:"content"`          // 通知内容 (富文本)
	NotificationPage string `json:"notificationPage"` // 通知页面
	StartDate        string `json:"startDate"`        // 通知开始日期，格式 "YYYY-MM-DD"
	EndDate          string `json:"endDate"`          // 通知结束日期，格式 "YYYY-MM-DD"
	StartTime        string `json:"startTime"`        // 每天通知开始时间，格式 "HH:MM:SS"
	EndTime          string `json:"endTime"`          // 每天通知结束时间，格式 "HH:MM:SS"
}

type PaymentReq struct {
	Id        string `json:"id"`
	PayMethod string `json:"pay_method"`
}

type PaymentResp struct {
	PrepayData interface{} `json:"prepay_data"`
	PrepayId   string      `json:"prepay_id"`
	OrderID    int64       `json:"order_id"`
}

type Product struct {
	ProductName string    `json:"product_name"`
	ProductEn   string    `json:"product_en"`
	Description string    `json:"description"`
	Notes       string    `json:"notes,optional"`
	SellPrice   float64   `json:"sell_price"`
	Features    []Feature `json:"features"` // 关联功能列表
}

type ProductResponse struct {
	Product
}

type PromotionLinkItem struct {
	Id            int64  `json:"id"`                       // 链接ID
	Name          string `json:"name"`                     // 链接名称
	Url           string `json:"url"`                      // 推广链接URL
	ClickCount    int64  `json:"click_count"`              // 点击数
	PayCount      int64  `json:"pay_count"`                // 付费次数
	PayAmount     string `json:"pay_amount"`               // 付费金额
	CreateTime    string `json:"create_time"`              // 创建时间
	LastClickTime string `json:"last_click_time,optional"` // 最后点击时间
	LastPayTime   string `json:"last_pay_time,optional"`   // 最后付费时间
}

type PromotionStatsHistoryItem struct {
	Id         int64   `json:"id"`          // 记录ID
	LinkId     int64   `json:"link_id"`     // 链接ID
	PayAmount  float64 `json:"pay_amount"`  // 金额
	ClickCount int64   `json:"click_count"` // 点击数
	PayCount   int64   `json:"pay_count"`   // 付费次数
	StatsDate  string  `json:"stats_date"`  // 统计日期
}

type Query struct {
	Id          int64                  `json:"id"`           // 主键ID
	OrderId     int64                  `json:"order_id"`     // 订单ID
	UserId      int64                  `json:"user_id"`      // 用户ID
	ProductName string                 `json:"product_name"` // 产品ID
	QueryParams map[string]interface{} `json:"query_params"`
	QueryData   []QueryItem            `json:"query_data"`
	CreateTime  string                 `json:"create_time"` // 创建时间
	UpdateTime  string                 `json:"update_time"` // 更新时间
	QueryState  string                 `json:"query_state"` // 查询状态
}

type QueryDetailByOrderIdReq struct {
	OrderId int64 `path:"order_id"`
}

type QueryDetailByOrderIdResp struct {
	Query
}

type QueryDetailByOrderNoReq struct {
	OrderNo string `path:"order_no"`
}

type QueryDetailByOrderNoResp struct {
	Query
}

type QueryDetailReq struct {
	Id int64 `path:"id"`
}

type QueryDetailResp struct {
	Query
}

type QueryExampleReq struct {
	Feature string `form:"feature"`
}

type QueryExampleResp struct {
	Query
}

type QueryItem struct {
	Feature interface{} `json:"feature"`
	Data    interface{} `json:"data"` // 这里可以是 map 或 具体的 struct
}

type QueryListReq struct {
	Page     int64 `form:"page"`      // 页码
	PageSize int64 `form:"page_size"` // 每页数据量
}

type QueryListResp struct {
	Total int64   `json:"total"` // 总记录数
	List  []Query `json:"list"`  // 查询列表
}

type QueryProvisionalOrderReq struct {
	Id string `path:"id"`
}

type QueryProvisionalOrderResp struct {
	QueryParams map[string]interface{} `json:"query_params"`
	Product     Product                `json:"product"`
}

type QueryReq struct {
	Data string `json:"data" validate:"required"`
}

type QueryResp struct {
	Id string `json:"id"`
}

type QueryRetryReq struct {
	Id int64 `path:"id"`
}

type QueryRetryResp struct {
}

type QueryServiceReq struct {
	Product string `path:"product"`
	Data    string `json:"data" validate:"required"`
}

type QueryServiceResp struct {
	Id string `json:"id"`
}

type QuerySingleTestReq struct {
	Params map[string]interface{} `json:"params"`
	Api    string                 `json:"api"`
}

type QuerySingleTestResp struct {
	Data interface{} `json:"data"`
	Api  string      `json:"api"`
}

type RecordLinkClickReq struct {
	Path string `path:"path"` // 链接路径
}

type RecordLinkClickResp struct {
	Success bool `json:"success"` // 是否成功
}

type RegisterReq struct {
	Mobile   string `json:"mobile" validate:"required,mobile"`
	Password string `json:"password" validate:"required,min=11,max=11,password"`
	Code     string `json:"code" validate:"required"`
}

type RegisterResp struct {
	AccessToken  string `json:"accessToken"`
	AccessExpire int64  `json:"accessExpire"`
	RefreshAfter int64  `json:"refreshAfter"`
}

type RoleListItem struct {
	Id          int64   `json:"id"`          // 角色ID
	RoleName    string  `json:"role_name"`   // 角色名称
	RoleCode    string  `json:"role_code"`   // 角色编码
	Description string  `json:"description"` // 角色描述
	Status      int64   `json:"status"`      // 状态：0-禁用，1-启用
	Sort        int64   `json:"sort"`        // 排序
	CreateTime  string  `json:"create_time"` // 创建时间
	MenuIds     []int64 `json:"menu_ids"`    // 关联的菜单ID列表
}

type UpdateMenuReq struct {
	Id        int64                  `path:"id"`                 // 菜单ID
	Pid       int64                  `json:"pid,optional"`       // 父菜单ID
	Name      string                 `json:"name"`               // 路由名称
	Path      string                 `json:"path,optional"`      // 路由路径
	Component string                 `json:"component,optional"` // 组件路径
	Redirect  string                 `json:"redirect,optional"`  // 重定向路径
	Meta      map[string]interface{} `json:"meta"`               // 路由元数据
	Status    int64                  `json:"status,optional"`    // 状态：0-禁用，1-启用
	Type      string                 `json:"type"`               // 类型
	Sort      int64                  `json:"sort,optional"`      // 排序
}

type UpdateMenuResp struct {
	Success bool `json:"success"` // 是否成功
}

type UpdatePromotionLinkReq struct {
	Id   int64   `path:"id"`            // 链接ID
	Name *string `json:"name,optional"` // 链接名称
}

type UpdatePromotionLinkResp struct {
	Success bool `json:"success"` // 是否成功
}

type UpdateQueryDataReq struct {
	Id        int64  `json:"id"`         // 查询ID
	QueryData string `json:"query_data"` // 查询数据(未加密的JSON)
}

type UpdateQueryDataResp struct {
	Id        int64  `json:"id"`
	UpdatedAt string `json:"updated_at"` // 更新时间
}

type UpdateRoleReq struct {
	Id          int64   `path:"id"`                   // 角色ID
	RoleName    *string `json:"role_name,optional"`   // 角色名称
	RoleCode    *string `json:"role_code,optional"`   // 角色编码
	Description *string `json:"description,optional"` // 角色描述
	Status      *int64  `json:"status,optional"`      // 状态：0-禁用，1-启用
	Sort        *int64  `json:"sort,optional"`        // 排序
	MenuIds     []int64 `json:"menu_ids,optional"`    // 关联的菜单ID列表
}

type UpdateRoleResp struct {
	Success bool `json:"success"` // 是否成功
}

type User struct {
	Id       int64  `json:"id"`
	Mobile   string `json:"mobile"`
	NickName string `json:"nickName"`
}

type UserInfoResp struct {
	UserInfo User `json:"userInfo"`
}

type UserListItem struct {
	Id         int64   `json:"id"`          // 用户ID
	Username   string  `json:"username"`    // 用户名
	RealName   string  `json:"real_name"`   // 真实姓名
	Status     int64   `json:"status"`      // 状态：0-禁用，1-启用
	CreateTime string  `json:"create_time"` // 创建时间
	RoleIds    []int64 `json:"role_ids"`    // 关联的角色ID列表
}

type WXH5AuthReq struct {
	Code string `json:"code"`
}

type WXH5AuthResp struct {
	AccessToken  string `json:"accessToken"`
	AccessExpire int64  `json:"accessExpire"`
	RefreshAfter int64  `json:"refreshAfter"`
}

type WXMiniAuthReq struct {
	Code string `json:"code"`
}

type WXMiniAuthResp struct {
	AccessToken  string `json:"accessToken"`
	AccessExpire int64  `json:"accessExpire"`
	RefreshAfter int64  `json:"refreshAfter"`
}

type SendSmsReq struct {
	Mobile     string `json:"mobile" validate:"required,mobile"`
	ActionType string `json:"actionType" validate:"required,oneof=login register query"`
}
