package model

import (
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
)

var _ AdminDictDataModel = (*customAdminDictDataModel)(nil)

type (
	// AdminDictDataModel is an interface to be customized, add more methods here,
	// and implement the added methods in customAdminDictDataModel.
	AdminDictDataModel interface {
		adminDictDataModel
	}

	customAdminDictDataModel struct {
		*defaultAdminDictDataModel
	}
)

// NewAdminDictDataModel returns a model for the database table.
func NewAdminDictDataModel(conn sqlx.SqlConn, c cache.CacheConf) AdminDictDataModel {
	return &customAdminDictDataModel{
		defaultAdminDictDataModel: newAdminDictDataModel(conn, c),
	}
}
