package model

import (
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
)

var _ AdminPromotionOrderModel = (*customAdminPromotionOrderModel)(nil)

type (
	// AdminPromotionOrderModel is an interface to be customized, add more methods here,
	// and implement the added methods in customAdminPromotionOrderModel.
	AdminPromotionOrderModel interface {
		adminPromotionOrderModel
	}

	customAdminPromotionOrderModel struct {
		*defaultAdminPromotionOrderModel
	}
)

// NewAdminPromotionOrderModel returns a model for the database table.
func NewAdminPromotionOrderModel(conn sqlx.SqlConn, c cache.CacheConf) AdminPromotionOrderModel {
	return &customAdminPromotionOrderModel{
		defaultAdminPromotionOrderModel: newAdminPromotionOrderModel(conn, c),
	}
}
