package model

import (
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
)

var _ AdminRoleApiModel = (*customAdminRoleApiModel)(nil)

type (
	// AdminRoleApiModel is an interface to be customized, add more methods here,
	// and implement the added methods in customAdminRoleApiModel.
	AdminRoleApiModel interface {
		adminRoleApiModel
	}

	customAdminRoleApiModel struct {
		*defaultAdminRoleApiModel
	}
)

// NewAdminRoleApiModel returns a model for the database table.
func NewAdminRoleApiModel(conn sqlx.SqlConn, c cache.CacheConf) AdminRoleApiModel {
	return &customAdminRoleApiModel{
		defaultAdminRoleApiModel: newAdminRoleApiModel(conn, c),
	}
}
