package model

import (
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
)

var _ FeatureModel = (*customFeatureModel)(nil)

type (
	// FeatureModel is an interface to be customized, add more methods here,
	// and implement the added methods in customFeatureModel.
	FeatureModel interface {
		featureModel
	}

	customFeatureModel struct {
		*defaultFeatureModel
	}
)

// NewFeatureModel returns a model for the database table.
func NewFeatureModel(conn sqlx.SqlConn, c cache.CacheConf) FeatureModel {
	return &customFeatureModel{
		defaultFeatureModel: newFeatureModel(conn, c),
	}
}
