package model

import (
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
)

var _ GlobalNotificationsModel = (*customGlobalNotificationsModel)(nil)

type (
	// GlobalNotificationsModel is an interface to be customized, add more methods here,
	// and implement the added methods in customGlobalNotificationsModel.
	GlobalNotificationsModel interface {
		globalNotificationsModel
	}

	customGlobalNotificationsModel struct {
		*defaultGlobalNotificationsModel
	}
)

// NewGlobalNotificationsModel returns a model for the database table.
func NewGlobalNotificationsModel(conn sqlx.SqlConn, c cache.CacheConf) GlobalNotificationsModel {
	return &customGlobalNotificationsModel{
		defaultGlobalNotificationsModel: newGlobalNotificationsModel(conn, c),
	}
}
