package model

import (
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
)

var _ ProductFeatureModel = (*customProductFeatureModel)(nil)

type (
	// ProductFeatureModel is an interface to be customized, add more methods here,
	// and implement the added methods in customProductFeatureModel.
	ProductFeatureModel interface {
		productFeatureModel
	}

	customProductFeatureModel struct {
		*defaultProductFeatureModel
	}
)

// NewProductFeatureModel returns a model for the database table.
func NewProductFeatureModel(conn sqlx.SqlConn, c cache.CacheConf) ProductFeatureModel {
	return &customProductFeatureModel{
		defaultProductFeatureModel: newProductFeatureModel(conn, c),
	}
}
