package model

import (
	"github.com/zeromicro/go-zero/core/stores/cache"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
)

var _ ProductRenderModel = (*customProductRenderModel)(nil)

type (
	// ProductRenderModel is an interface to be customized, add more methods here,
	// and implement the added methods in customProductRenderModel.
	ProductRenderModel interface {
		productRenderModel
	}

	customProductRenderModel struct {
		*defaultProductRenderModel
	}
)

// NewProductRenderModel returns a model for the database table.
func NewProductRenderModel(conn sqlx.SqlConn, c cache.CacheConf) ProductRenderModel {
	return &customProductRenderModel{
		defaultProductRenderModel: newProductRenderModel(conn, c),
	}
}
